#ifndef ONI_H
#define ONI_H

#include "Daodan.h"
#include "Oni_GL.h"
#include <windows.h>
#include "Oni_GameState.h"

typedef unsigned char onibool;

#define WMcMessage_Quit 0x39 // WM_QUIT equivalent.

typedef struct {
	HINSTANCE Instance;
	HWND Window;
} ONtPlatformData;

typedef struct {
	int16_t left;
	int16_t top;
	int16_t right;
	int16_t bottom;
} UUtRect;

typedef struct OBJtMethods
{
	void*     rNew;
	void*   rSetDefaults;
	void*    rDelete;
	void*   rIsInvalid;
	void*   rLevelBegin;
	void*    rLevelEnd;

	void*     rDraw;
	void*   rEnumerate;
	void* rGetBoundingSphere;
	void*   rOSDGetName;
	void*   rOSDSetName;
	void*  rIntersectsLine;
	void*  rUpdatePosition;

	void* rGetOSD;
	void* rGetOSDWriteSize;
	void* rSetOSD;

	void* rWrite;
	void* rRead;

	void* rSearch;

	void* rGetClassVisible;
	void* rSetClassVisible;

	void* rGetUniqueOSD;
} OBJtMethods;

void ONICALL TMrInstance_GetDataPtr_List( 
	char Tag[4],		//as in 'ONWC'
	int MaxCount,		//# of elements in PointerList
	void** PointerList, //Where the found pointers go
	int* FoundCount		//Where the number of pointers found go.
);

UUmType(WMtWindow);

#include "Oni_Symbols.h"

#endif
